Smart.Editor iFrame Mode

Editor for Angular

Angular standalone version of this topic (compatible with Angular 17+). Import both the Smart UI component and module in the standalone component.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { RouterOutlet } from '@angular/router';
import { EditorComponent, EditorModule } from 'smart-webcomponents-angular/editor';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [CommonModule, EditorModule, RouterOutlet],
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css'],
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  @ViewChild('editor', { read: EditorComponent, static: false }) editor!: EditorComponent;
}
<!-- app.component.html -->
<smart-editor #editor></smart-editor>

Use this.editor for API methods in this topic.

iFrame Editor

Smart.Editor's content section can be easily stylied or modifed via CSS or Javascript. However the Editor has an additional iframe mode which places the Editor's content inside an iframe which provides an isolated DOM that does not allow styles and scripts to leak in.

The iframe mode is not enabled by default. A property of type object called iframeSettings that configures the iframe mode with the following settings:

  • enabled - determines whether iframe mode is enabled or not.
  • attributes - an object that defines attributes for the iframe, for example:
    attributes: {
        height: 500
    }

    All native iframe attributes are supported.

  • resources - an object that determines what styles and scripts should be imported into the iframe's DOM. For example:
      resources: {
          'style': {
              href: 'styles.css'
            },
            'script': {
                src: 'index.js',
                type: 'module'
            }
        }

    The href and src attributes should point to the file location and name.

    The type attribute determines whether the JS file should be loaded as a module or not.

For AI tooling

Developer Quick Reference

Topic: editor-iframe-mode   Component: Editor   Framework: Angular

Main methods: (none detected)

Common config keys: (none detected)

Implementation Notes

Compatibility: Angular 17+ (standalone)   API access pattern: @ViewChild(...) + this.component.method()

Lifecycle guidance: Bind inputs declaratively and call imperative API through @ViewChild in/after ngAfterViewInit.

Common pitfalls:

  • Using @ViewChild API too early (before view init).
  • Omitting standalone imports for Smart modules in @Component.imports.
  • Type mismatches between configuration fields and template bindings.

Validation checklist:

  • Ensure module import exists in standalone component imports array.
  • Use typed @ViewChild(..., { read: ComponentType }).
  • Call imperative methods after view initialization.

Smart.Editor iFrame Mode

Editor for React

React version of this topic (compatible with React 19+). Keep the same configuration logic from JavaScript and pass it as component props.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import React, { useMemo, useRef } from 'react';
import { Editor } from 'smart-webcomponents-react/editor';
import 'smart-webcomponents-react/source/styles/smart.default.css';

export default function App() {
  const componentRef = useRef(null);
  const componentProps = useMemo(() => ({
    // Copy this topic's JavaScript configuration here.
  }), []);

  return <Editor ref={componentRef} {...componentProps}></Editor>;
}

Use componentRef.current for API methods in this topic.

iFrame Editor

Smart.Editor's content section can be easily stylied or modifed via CSS or Javascript. However the Editor has an additional iframe mode which places the Editor's content inside an iframe which provides an isolated DOM that does not allow styles and scripts to leak in.

The iframe mode is not enabled by default. A property of type object called iframeSettings that configures the iframe mode with the following settings:

  • enabled - determines whether iframe mode is enabled or not.
  • attributes - an object that defines attributes for the iframe, for example:
    attributes: {
        height: 500
    }

    All native iframe attributes are supported.

  • resources - an object that determines what styles and scripts should be imported into the iframe's DOM. For example:
      resources: {
          'style': {
              href: 'styles.css'
            },
            'script': {
                src: 'index.js',
                type: 'module'
            }
        }

    The href and src attributes should point to the file location and name.

    The type attribute determines whether the JS file should be loaded as a module or not.

For AI tooling

Developer Quick Reference

Topic: editor-iframe-mode   Component: Editor   Framework: React

Main methods: (none detected)

Common config keys: (none detected)

Implementation Notes

Compatibility: React 19+   API access pattern: const componentRef = useRef(null) + componentRef.current.method()

Lifecycle guidance: Use useMemo for large config objects and call imperative API through componentRef.current after first render.

Common pitfalls:

  • Recreating columns/dataSource objects on every render can reset component state.
  • Calling API methods before ref is available causes runtime errors.
  • Mixing controlled and imperative updates without sync can lead to stale UI.

Validation checklist:

  • Keep config objects memoized when possible.
  • Guard API calls with ref existence checks.
  • Verify CSS theme import is present once per app.

Smart.Editor iFrame Mode

Editor for Vue

Vue 3 version using Smart custom elements and template refs.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

<script setup>
import { onMounted, ref } from 'vue';
import 'smart-webcomponents/source/styles/smart.default.css';
import 'smart-webcomponents/source/modules/smart.editor.js';

const component = ref();
const componentProps = {
  // Copy this topic's JavaScript configuration here.
};

onMounted(() => {
  Object.assign(component.value, componentProps);
});
</script>

<template>
  <smart-editor ref="component"></smart-editor>
</template>

Use component.value for API methods in this topic.

iFrame Editor

Smart.Editor's content section can be easily stylied or modifed via CSS or Javascript. However the Editor has an additional iframe mode which places the Editor's content inside an iframe which provides an isolated DOM that does not allow styles and scripts to leak in.

The iframe mode is not enabled by default. A property of type object called iframeSettings that configures the iframe mode with the following settings:

  • enabled - determines whether iframe mode is enabled or not.
  • attributes - an object that defines attributes for the iframe, for example:
    attributes: {
        height: 500
    }

    All native iframe attributes are supported.

  • resources - an object that determines what styles and scripts should be imported into the iframe's DOM. For example:
      resources: {
          'style': {
              href: 'styles.css'
            },
            'script': {
                src: 'index.js',
                type: 'module'
            }
        }

    The href and src attributes should point to the file location and name.

    The type attribute determines whether the JS file should be loaded as a module or not.

For AI tooling

Developer Quick Reference

Topic: editor-iframe-mode   Component: Editor   Framework: Vue

Main methods: (none detected)

Common config keys: (none detected)

Implementation Notes

Compatibility: Vue 3+   API access pattern: const component = ref() + component.value.method()

Lifecycle guidance: Use template refs with